class Transformer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  d_model : int
  nhead : int
  batch_first : bool
  encoder : __torch__.torch.nn.modules.transformer.TransformerEncoder
  decoder : __torch__.torch.nn.modules.transformer.TransformerDecoder
  def forward(self: __torch__.torch.nn.modules.transformer.Transformer,
    src: Tensor,
    tgt: Tensor,
    src_mask: Optional[Tensor]=None,
    tgt_mask: Optional[Tensor]=None,
    memory_mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    tgt_key_padding_mask: Optional[Tensor]=None,
    memory_key_padding_mask: Optional[Tensor]=None) -> Tensor:
    _0 = "the batch number of src and tgt must be equal"
    _1 = "the feature number of src and tgt must be equal to d_model"
    is_batched = torch.eq(torch.dim(src), 3)
    batch_first = self.batch_first
    if torch.__not__(batch_first):
      _3 = torch.ne(torch.size(src, 1), torch.size(tgt, 1))
      _2 = _3
    else:
      _2 = False
    if _2:
      _4 = is_batched
    else:
      _4 = False
    if _4:
      ops.prim.RaiseException(_0)
    else:
      batch_first0 = self.batch_first
      if batch_first0:
        _6 = torch.ne(torch.size(src, 0), torch.size(tgt, 0))
        _5 = _6
      else:
        _5 = False
      if _5:
        _7 = is_batched
      else:
        _7 = False
      if _7:
        ops.prim.RaiseException(_0)
      else:
        pass
    _8 = torch.size(src, -1)
    d_model = self.d_model
    if torch.ne(_8, d_model):
      _9 = True
    else:
      _10 = torch.size(tgt, -1)
      d_model0 = self.d_model
      _9 = torch.ne(_10, d_model0)
    if _9:
      ops.prim.RaiseException(_1)
    else:
      pass
    encoder = self.encoder
    memory = (encoder).forward(src, src_mask, src_key_padding_mask, )
    decoder = self.decoder
    output = (decoder).forward(tgt, memory, tgt_mask, memory_mask, tgt_key_padding_mask, memory_key_padding_mask, )
    return output
class TransformerEncoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_layers : int
  layers : __torch__.torch.nn.modules.container.___torch_mangle_23.ModuleList
  norm : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  def forward(self: __torch__.torch.nn.modules.transformer.TransformerEncoder,
    src: Tensor,
    mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None) -> Tensor:
    layers = self.layers
    _0 = getattr(layers, "0")
    output = (_0).forward(src, mask, src_key_padding_mask, )
    norm = self.norm
    return (norm).forward(output, )
class TransformerEncoderLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  self_attn : __torch__.torch.nn.modules.activation.MultiheadAttention
  linear1 : __torch__.torch.nn.modules.linear.Linear
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  linear2 : __torch__.torch.nn.modules.linear.___torch_mangle_21.Linear
  norm1 : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  norm2 : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  dropout1 : __torch__.torch.nn.modules.dropout.Dropout
  dropout2 : __torch__.torch.nn.modules.dropout.Dropout
  norm_first : Final[bool] = False
  def forward(self: __torch__.torch.nn.modules.transformer.TransformerEncoderLayer,
    src: Tensor,
    src_mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None) -> Tensor:
    norm1 = self.norm1
    _11 = (self)._sa_block(src, src_mask, src_key_padding_mask, )
    x = (norm1).forward(torch.add(src, _11), )
    norm2 = self.norm2
    x0 = (norm2).forward(torch.add(x, (self)._ff_block(x, )), )
    return x0
  def _sa_block(self: __torch__.torch.nn.modules.transformer.TransformerEncoderLayer,
    x: Tensor,
    attn_mask: Optional[Tensor],
    key_padding_mask: Optional[Tensor]) -> Tensor:
    self_attn = self.self_attn
    _12 = (self_attn).forward(x, x, x, key_padding_mask, False, attn_mask, True, )
    x1 = (_12)[0]
    dropout1 = self.dropout1
    return (dropout1).forward(x1, )
  def _ff_block(self: __torch__.torch.nn.modules.transformer.TransformerEncoderLayer,
    x: Tensor) -> Tensor:
    linear2 = self.linear2
    dropout = self.dropout
    linear1 = self.linear1
    _13 = __torch__.torch.nn.functional.relu((linear1).forward(x, ), False, )
    x2 = (linear2).forward((dropout).forward(_13, ), )
    dropout2 = self.dropout2
    return (dropout2).forward(x2, )
class TransformerDecoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_layers : int
  layers : __torch__.torch.nn.modules.container.___torch_mangle_24.ModuleList
  norm : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  def forward(self: __torch__.torch.nn.modules.transformer.TransformerDecoder,
    tgt: Tensor,
    memory: Tensor,
    tgt_mask: Optional[Tensor]=None,
    memory_mask: Optional[Tensor]=None,
    tgt_key_padding_mask: Optional[Tensor]=None,
    memory_key_padding_mask: Optional[Tensor]=None) -> Tensor:
    layers = self.layers
    _0 = getattr(layers, "0")
    output = (_0).forward(tgt, memory, tgt_mask, memory_mask, tgt_key_padding_mask, memory_key_padding_mask, )
    norm = self.norm
    return (norm).forward(output, )
class TransformerDecoderLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  self_attn : __torch__.torch.nn.modules.activation.MultiheadAttention
  multihead_attn : __torch__.torch.nn.modules.activation.MultiheadAttention
  linear1 : __torch__.torch.nn.modules.linear.Linear
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  linear2 : __torch__.torch.nn.modules.linear.___torch_mangle_21.Linear
  norm1 : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  norm2 : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  norm3 : __torch__.torch.nn.modules.normalization.___torch_mangle_22.LayerNorm
  dropout1 : __torch__.torch.nn.modules.dropout.Dropout
  dropout2 : __torch__.torch.nn.modules.dropout.Dropout
  dropout3 : __torch__.torch.nn.modules.dropout.Dropout
  norm_first : Final[bool] = False
  def forward(self: __torch__.torch.nn.modules.transformer.TransformerDecoderLayer,
    tgt: Tensor,
    memory: Tensor,
    tgt_mask: Optional[Tensor]=None,
    memory_mask: Optional[Tensor]=None,
    tgt_key_padding_mask: Optional[Tensor]=None,
    memory_key_padding_mask: Optional[Tensor]=None) -> Tensor:
    norm1 = self.norm1
    _14 = (self)._sa_block(tgt, tgt_mask, tgt_key_padding_mask, )
    x = (norm1).forward(torch.add(tgt, _14), )
    norm2 = self.norm2
    _15 = (self)._mha_block(x, memory, memory_mask, memory_key_padding_mask, )
    x3 = (norm2).forward(torch.add(x, _15), )
    norm3 = self.norm3
    _16 = torch.add(x3, (self)._ff_block(x3, ))
    return (norm3).forward(_16, )
  def _sa_block(self: __torch__.torch.nn.modules.transformer.TransformerDecoderLayer,
    x: Tensor,
    attn_mask: Optional[Tensor],
    key_padding_mask: Optional[Tensor]) -> Tensor:
    self_attn = self.self_attn
    _17 = (self_attn).forward(x, x, x, key_padding_mask, False, attn_mask, True, )
    x4 = (_17)[0]
    dropout1 = self.dropout1
    return (dropout1).forward(x4, )
  def _mha_block(self: __torch__.torch.nn.modules.transformer.TransformerDecoderLayer,
    x: Tensor,
    mem: Tensor,
    attn_mask: Optional[Tensor],
    key_padding_mask: Optional[Tensor]) -> Tensor:
    multihead_attn = self.multihead_attn
    _18 = (multihead_attn).forward(x, mem, mem, key_padding_mask, False, attn_mask, True, )
    x5 = (_18)[0]
    dropout2 = self.dropout2
    return (dropout2).forward(x5, )
  def _ff_block(self: __torch__.torch.nn.modules.transformer.TransformerDecoderLayer,
    x: Tensor) -> Tensor:
    linear2 = self.linear2
    dropout = self.dropout
    linear1 = self.linear1
    _19 = __torch__.torch.nn.functional.relu((linear1).forward(x, ), False, )
    x6 = (linear2).forward((dropout).forward(_19, ), )
    dropout3 = self.dropout3
    return (dropout3).forward(x6, )
